Index: issm/trunk-jpl/packagers/mac/package-issm-mac-binaries-matlab.sh
===================================================================
--- issm/trunk-jpl/packagers/mac/package-issm-mac-binaries-matlab.sh	(revision 25878)
+++ issm/trunk-jpl/packagers/mac/package-issm-mac-binaries-matlab.sh	(revision 25879)
@@ -105,5 +105,5 @@
 		--password ${PASSWORD} \
 		${SIGNED_REPO_URL} \
-		${SIGNED_REPO_COPY}
+		${SIGNED_REPO_COPY} > /dev/null 2>&1
 }
 checkout_unsigned_repo_copy(){
@@ -115,5 +115,5 @@
 		--password ${PASSWORD} \
 		${UNSIGNED_REPO_URL} \
-		${UNSIGNED_REPO_COPY}
+		${UNSIGNED_REPO_COPY} > /dev/null 2>&1
 }
 validate_signed_repo_copy(){
@@ -246,5 +246,5 @@
 			# Check that MATLAB did not exit in error
 			matlabExitCode=`echo $?`
-			matlabExitedInError=`grep -E "Activation cannot proceed|license|Error" matlab.log | wc -l`
+			matlabExitedInError=`grep -E "Activation cannot proceed|Error in matlab_run" matlab.log | wc -l`
 
 			if [[ ${matlabExitCode} -ne 0 || ${matlabExitedInError} -ne 0 ]]; then
@@ -306,9 +306,5 @@
 		--message "ADD: New lock file" ${SIGNED_REPO_COPY}
 
-	# Save current working copy revision number
-	svn up ${SIGNED_REPO_COPY}
-	CURRENT_REV=$(svn info --show-item last-changed-revision ${SIGNED_REPO_COPY})
-
-	# Check out copy of SVN repository for unsigned packages
+	# Check out copy of repository for unsigned packages
 	checkout_unsigned_repo_copy
 
@@ -335,5 +331,5 @@
 		echo "Attempting to sign existing package again"
 		echo $(date +'%Y-%m-%d-%H-%M-%S') > ${UNSIGNED_REPO_COPY}/${RETRIGGER_SIGNING_FILE} # Write datetime stamp to file to ensure modification is made
-		svn add ${UNSIGNED_REPO_COPY}/${RETRIGGER_SIGNING_FILE} > /dev/null 2>&1
+		svcheckout_unsigned_repo_copyn add ${UNSIGNED_REPO_COPY}/${RETRIGGER_SIGNING_FILE} > /dev/null 2>&1
 		svn commit \
 			--trust-server-cert \
@@ -353,13 +349,12 @@
 		sleep ${SIGNING_CHECK_PERIOD}
 		svn up ${SIGNED_REPO_COPY}
-		NEW_REV=$(svn info --show-item last-changed-revision ${SIGNED_REPO_COPY})
-
-		if [ ${NEW_REV} -ne ${CURRENT_REV} ]; then
+
+		if [ ! -f ${SIGNED_REPO_COPY}/${SIGNING_LOCK_FILE} ]; then
 			IN_PROCESS=0
 
+			# Retrieve notarization lock file
 			svn up ${SIGNED_REPO_COPY}/${NOTARIZATION_LOGFILE}
-			svn up ${SIGNED_REPO_COPY}/${COMPRESSED_PKG}
-
-			# No error, so check status
+
+			# Check status
 			STATUS=$(grep 'Status:' ${SIGNED_REPO_COPY}/${NOTARIZATION_LOGFILE} | sed -e 's/[[:space:]]*Status: //')
 			if [[ "${STATUS}" == "success" ]]; then
@@ -387,4 +382,7 @@
 # Handle result of signing
 if [ ${SUCCESS} -eq 1 ]; then
+	# Retrieve signed and notarized package
+	svn up ${SIGNED_REPO_COPY}/${COMPRESSED_PKG}
+
 	# Transfer signed package to ISSM Web site
 	echo "Transferring signed package to ISSM Web site"
Index: issm/trunk-jpl/packagers/mac/package-issm-mac-binaries-python.sh
===================================================================
--- issm/trunk-jpl/packagers/mac/package-issm-mac-binaries-python.sh	(revision 25878)
+++ issm/trunk-jpl/packagers/mac/package-issm-mac-binaries-python.sh	(revision 25879)
@@ -4,5 +4,5 @@
 # To be used after running,
 #
-#	${ISSM_DIR}/jenkins/jenkins.sh ${ISSM_DIR}/jenkins/pine_island-mac-binaries-matlab
+#	${ISSM_DIR}/jenkins/jenkins.sh ${ISSM_DIR}/jenkins/pine_island-mac-binaries-python
 #
 # in the context of a Jenkins project.
@@ -30,5 +30,5 @@
 #	Jenkins server. Debugging may be perfomed locally by running,
 #
-#		packagers/mac/sign-issm-mac-binaries-matlab.sh
+#		packagers/mac/sign-issm-mac-binaries-python.sh
 #
 #	with Apple Developer credentials.
@@ -104,5 +104,5 @@
 		--password ${PASSWORD} \
 		${SIGNED_REPO_URL} \
-		${SIGNED_REPO_COPY}
+		${SIGNED_REPO_COPY} > /dev/null 2>&1
 }
 checkout_unsigned_repo_copy(){
@@ -114,5 +114,5 @@
 		--password ${PASSWORD} \
 		${UNSIGNED_REPO_URL} \
-		${UNSIGNED_REPO_COPY}
+		${UNSIGNED_REPO_COPY} > /dev/null 2>&1
 }
 validate_signed_repo_copy(){
@@ -329,9 +329,5 @@
 		--message "ADD: New lock file" ${SIGNED_REPO_COPY}
 
-	# Save current working copy revision number
-	svn up ${SIGNED_REPO_COPY}
-	CURRENT_REV=$(svn info --show-item last-changed-revision ${SIGNED_REPO_COPY})
-
-	# Check out copy of SVN repository for unsigned packages
+	# Check out copy of repository for unsigned packages
 	checkout_unsigned_repo_copy
 
@@ -376,17 +372,16 @@
 		sleep ${SIGNING_CHECK_PERIOD}
 		svn up ${SIGNED_REPO_COPY}
-		NEW_REV=$(svn info --show-item last-changed-revision ${SIGNED_REPO_COPY})
-
-		if [ ${NEW_REV} -ne ${CURRENT_REV} ]; then
+
+		if [ ! -f ${SIGNED_REPO_COPY}/${SIGNING_LOCK_FILE} ]; then
 			IN_PROCESS=0
 
+			# Retrieve notarization lock file
 			svn up ${SIGNED_REPO_COPY}/${NOTARIZATION_LOGFILE}
-			svn up ${SIGNED_REPO_COPY}/${COMPRESSED_PKG}
-
-			# No error, so check status
+
+			# Check status
 			STATUS=$(grep 'Status:' ${SIGNED_REPO_COPY}/${NOTARIZATION_LOGFILE} | sed -e 's/[[:space:]]*Status: //')
 			if [[ "${STATUS}" == "success" ]]; then
 				echo "Notarization successful!"
-				
+
 				# Set flag indicating notarization was successful
 				SUCCESS=1
@@ -410,4 +405,7 @@
 # Handle result of signing
 if [ ${SUCCESS} -eq 1 ]; then
+	# Retrieve signed and notarized package
+	svn up ${SIGNED_REPO_COPY}/${COMPRESSED_PKG}
+
 	# Transfer signed package to ISSM Web site
 	echo "Transferring signed package to ISSM Web site"