Index: issm/trunk-jpl/packagers/mac/sign-issm-mac-binaries-matlab.sh
===================================================================
--- issm/trunk-jpl/packagers/mac/sign-issm-mac-binaries-matlab.sh	(revision 25879)
+++ issm/trunk-jpl/packagers/mac/sign-issm-mac-binaries-matlab.sh	(revision 25880)
@@ -80,5 +80,6 @@
 ALTOOL_PASSWORD="@keychain:**********" # altool password (assumed to be stored in keychain)
 ASC_PROVIDER="**********"
-NOTARIZATION_CHECK_ATTEMPTS=60
+MAX_SVN_ATTEMPTS=10
+NOTARIZATION_CHECK_ATTEMPTS=20
 NOTARIZATION_CHECK_PERIOD=60
 NOTARIZATION_LOGFILE="notarization.log"
@@ -249,11 +250,28 @@
 # Check out copy of repository for signed packages
 echo "Checking out copy of respository for signed packages"
-svn checkout \
-	--trust-server-cert \
-	--non-interactive \
-	--username ${USERNAME} \
-	--password ${PASSWORD} \
-	${SIGNED_REPO_URL} \
-	${SIGNED_REPO_COPY}
+SVN_ATTEMPT=0
+SVN_SUCCESS=0
+while [[ ${SVN_ATTEMPT} -lt ${MAX_SVN_ATTEMPTS} && ${SVN_SUCCESS} -eq 0 ]]; do
+	rm -rf ${SIGNED_REPO_COPY}
+	svn checkout \
+		--trust-server-cert \
+		--non-interactive \
+		--username ${USERNAME} \
+		--password ${PASSWORD} \
+		${SIGNED_REPO_URL} \
+		${SIGNED_REPO_COPY} > /dev/null 2>&1
+	if [ $? -eq 0 ]; then
+		SVN_SUCCESS=1
+		break
+	else
+		((++SVN_ATTEMPT))
+		sleep 5
+	fi
+done
+
+if [ ${SVN_SUCCESS} -eq 0 ]; then
+	echo "Checkout of respository for signed packages failed"
+	exit 1
+fi
 
 # Copy notarization file to repository for signed packages
@@ -264,4 +282,6 @@
 svn delete ${SIGNED_REPO_COPY}/${SIGNING_LOCK_FILE} > /dev/null 2>&1
 
+SVN_ATTEMPT=0
+SVN_SUCCESS=0
 if [ ${SUCCESS} -eq 1 ]; then
 	# Copy signed package to repository for signed packages
@@ -271,19 +291,47 @@
 	# Commit changes
 	echo "Committing changes to repository for signed packages"
-	svn commit \
-		--trust-server-cert \
-		--non-interactive \
-		--username ${USERNAME} \
-		--password ${PASSWORD} \
-		--message "CHG: New signed package (success)" ${SIGNED_REPO_COPY}
+	while [[ ${SVN_ATTEMPT} -lt ${MAX_SVN_ATTEMPTS} && ${SVN_SUCCESS} -eq 0 ]]; do
+		svn commit \
+			--trust-server-cert \
+			--non-interactive \
+			--username ${USERNAME} \
+			--password ${PASSWORD} \
+			--message "CHG: New signed package (success)" ${SIGNED_REPO_COPY} > /dev/null 2>&1
+		if [ $? -eq 0 ]; then
+			SVN_SUCCESS=1
+			break
+		else
+			((++SVN_ATTEMPT))
+			sleep 5
+		fi
+	done
+
+	if [ ${SVN_SUCCESS} -eq 0 ]; then
+		echo "Commit to respository for signed packages failed"
+		exit 1
+	fi
 else
 	# Commit changes
 	echo "Committing changes to repository for signed packages"
-	svn commit \
-		--trust-server-cert \
-		--non-interactive \
-		--username ${USERNAME} \
-		--password ${PASSWORD} \
-		--message "CHG: New signed package (failure)" ${SIGNED_REPO_COPY}
+	while [[ ${SVN_ATTEMPT} -lt ${MAX_SVN_ATTEMPTS} && ${SVN_SUCCESS} -eq 0 ]]; do
+		svn commit \
+			--trust-server-cert \
+			--non-interactive \
+			--username ${USERNAME} \
+			--password ${PASSWORD} \
+			--message "CHG: New signed package (failure)" ${SIGNED_REPO_COPY} > /dev/null 2>&1
+		if [ $? -eq 0 ]; then
+			SVN_SUCCESS=1
+			break
+		else
+			((++SVN_ATTEMPT))
+			sleep 5
+		fi
+	done
+
+	if [ ${SVN_SUCCESS} -eq 0 ]; then
+		echo "Commit to respository for signed packages failed"
+		exit 1
+	fi
 
 	exit 1
Index: issm/trunk-jpl/packagers/mac/sign-issm-mac-binaries-python.sh
===================================================================
--- issm/trunk-jpl/packagers/mac/sign-issm-mac-binaries-python.sh	(revision 25879)
+++ issm/trunk-jpl/packagers/mac/sign-issm-mac-binaries-python.sh	(revision 25880)
@@ -80,5 +80,6 @@
 ALTOOL_PASSWORD="@keychain:**********" # altool password (assumed to be stored in keychain)
 ASC_PROVIDER="**********"
-NOTARIZATION_CHECK_ATTEMPTS=60
+MAX_SVN_ATTEMPTS=10
+NOTARIZATION_CHECK_ATTEMPTS=20
 NOTARIZATION_CHECK_PERIOD=60
 NOTARIZATION_LOGFILE="notarization.log"
@@ -259,11 +260,28 @@
 # Check out copy of repository for signed packages
 echo "Checking out copy of respository for signed packages"
-svn checkout \
-	--trust-server-cert \
-	--non-interactive \
-	--username ${USERNAME} \
-	--password ${PASSWORD} \
-	${SIGNED_REPO_URL} \
-	${SIGNED_REPO_COPY}
+SVN_ATTEMPT=0
+SVN_SUCCESS=0
+while [[ ${SVN_ATTEMPT} -lt ${MAX_SVN_ATTEMPTS} && ${SVN_SUCCESS} -eq 0 ]]; do
+	rm -rf ${SIGNED_REPO_COPY}
+	svn checkout \
+		--trust-server-cert \
+		--non-interactive \
+		--username ${USERNAME} \
+		--password ${PASSWORD} \
+		${SIGNED_REPO_URL} \
+		${SIGNED_REPO_COPY} > /dev/null 2>&1
+	if [ $? -eq 0 ]; then
+		SVN_SUCCESS=1
+		break
+	else
+		((++SVN_ATTEMPT))
+		sleep 5
+	fi
+done
+
+if [ ${SVN_SUCCESS} -eq 0 ]; then
+	echo "Checkout of respository for signed packages failed"
+	exit 1
+fi
 
 # Copy notarization file to repository for signed packages
@@ -274,4 +292,6 @@
 svn delete ${SIGNED_REPO_COPY}/${SIGNING_LOCK_FILE}
 
+SVN_ATTEMPT=0
+SVN_SUCCESS=0
 if [ ${SUCCESS} -eq 1 ]; then
 	# Copy signed package to repository for signed packages
@@ -281,19 +301,47 @@
 	# Commit changes
 	echo "Committing changes to repository for signed packages"
-	svn commit \
-		--trust-server-cert \
-		--non-interactive \
-		--username ${USERNAME} \
-		--password ${PASSWORD} \
-		--message "CHG: New signed package (success)" ${SIGNED_REPO_COPY}
+	while [[ ${SVN_ATTEMPT} -lt ${MAX_SVN_ATTEMPTS} && ${SVN_SUCCESS} -eq 0 ]]; do
+		svn commit \
+			--trust-server-cert \
+			--non-interactive \
+			--username ${USERNAME} \
+			--password ${PASSWORD} \
+			--message "CHG: New signed package (success)" ${SIGNED_REPO_COPY} > /dev/null 2>&1
+		if [ $? -eq 0 ]; then
+			SVN_SUCCESS=1
+			break
+		else
+			((++SVN_ATTEMPT))
+			sleep 5
+		fi
+	done
+
+	if [ ${SVN_SUCCESS} -eq 0 ]; then
+		echo "Commit to respository for signed packages failed"
+		exit 1
+	fi
 else
 	# Commit changes
 	echo "Committing changes to repository for signed packages"
-	svn commit \
-		--trust-server-cert \
-		--non-interactive \
-		--username ${USERNAME} \
-		--password ${PASSWORD} \
-		--message "CHG: New signed package (failure)" ${SIGNED_REPO_COPY}
+	while [[ ${SVN_ATTEMPT} -lt ${MAX_SVN_ATTEMPTS} && ${SVN_SUCCESS} -eq 0 ]]; do
+		svn commit \
+			--trust-server-cert \
+			--non-interactive \
+			--username ${USERNAME} \
+			--password ${PASSWORD} \
+			--message "CHG: New signed package (failure)" ${SIGNED_REPO_COPY} > /dev/null 2>&1
+		if [ $? -eq 0 ]; then
+			SVN_SUCCESS=1
+			break
+		else
+			((++SVN_ATTEMPT))
+			sleep 5
+		fi
+	done
+
+	if [ ${SVN_SUCCESS} -eq 0 ]; then
+		echo "Commit to respository for signed packages failed"
+		exit 1
+	fi
 
 	exit 1